﻿using System;
using System.Runtime.InteropServices;

namespace WinApi
{
	internal static class UnsafeNativeMethods
	{
		[System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Globalization", "CA2101:SpecifyMarshalingForPInvokeStringArguments", MessageId = "NOTIFYICONDATA.szTip")]
		[System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Globalization", "CA2101:SpecifyMarshalingForPInvokeStringArguments", MessageId = "NOTIFYICONDATA.szInfoTitle")]
		[System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Globalization", "CA2101:SpecifyMarshalingForPInvokeStringArguments", MessageId = "NOTIFYICONDATA.szInfo")]
		[DllImport("shell32.dll", CharSet = CharSet.Unicode)]
		public static extern int Shell_NotifyIcon(int zprava, NativeMethods.NOTIFYICONDATA pNID);
	}

	internal static class NativeMethods
	{
		public const int WM_LBUTTONUP = 0x0202;
		public const int WM_APP = 0x8000;
		public const int wm_notify_ikona = WM_APP + 1;

		public const int
			NIF_ICON = 0x00000002,
			NIF_MESSAGE = 0x00000001,
			NIF_TIP = 0x00000004,
			NIF_INFO = 0x00000010,
			NIF_STATE = 0x00000008,
			NIF_SHOWTIP = 0x00000080;

		public const int
			NIM_ADD = 0x00000000,
			NIM_MODIFY = 0x00000001,
			NIM_DELETE = 0x00000002,
			NIM_SETFOCUS = 0x00000003,
			NIM_SETVERSION = 0x00000004;

		public const int NOTIFYICON_VERSION_4 = 4;

		[StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
		public class NOTIFYICONDATA
		{
			public int cbSize = Marshal.SizeOf(typeof(NOTIFYICONDATA));
			[System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Security", "CA2111:PointersShouldNotBeVisible")]
			public IntPtr hWnd = IntPtr.Zero;
			public int uID = 0;
			public int uFlags = 0;
			public int uCallbackMessage = 0;
			[System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Security", "CA2111:PointersShouldNotBeVisible")]
			public IntPtr hIcon = IntPtr.Zero;
			[MarshalAs(UnmanagedType.ByValTStr, SizeConst = 128)]
			public string szTip;
			public int dwState = 0;
			public int dwStateMask = 0;
			[MarshalAs(UnmanagedType.ByValTStr, SizeConst = 256)]
			public string szInfo;
			public int uTimeoutOrVersion = 0;
			[MarshalAs(UnmanagedType.ByValTStr, SizeConst = 64)]
			public string szInfoTitle;
			public int dwInfoFlags = 0;
			public Guid guidItem;
			[System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Security", "CA2111:PointersShouldNotBeVisible")]
			public IntPtr hBalloonicon = IntPtr.Zero;
		}

	}
}
